<html>
<head>
<title>OgreSmallVector.h File Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#namespaces">Namespaces</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">OgreSmallVector.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;algorithm&gt;</code><br/>
<code>#include &lt;cassert&gt;</code><br/>
<code>#include &lt;cstddef&gt;</code><br/>
<code>#include &lt;cstdlib&gt;</code><br/>
<code>#include &lt;cstring&gt;</code><br/>
<code>#include &lt;iterator&gt;</code><br/>
<code>#include &lt;memory&gt;</code><br/>
</div>
<p><a href="OgreSmallVector_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1isPodLike.html">Ogre::isPodLike&lt; T &gt;</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1isPodLike_3_01bool_01_4.html">Ogre::isPodLike&lt; bool &gt;</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1isPodLike_3_01char_01_4.html">Ogre::isPodLike&lt; char &gt;</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1isPodLike_3_01signed_01char_01_4.html">Ogre::isPodLike&lt; signed char &gt;</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1isPodLike_3_01unsigned_01char_01_4.html">Ogre::isPodLike&lt; unsigned char &gt;</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1isPodLike_3_01int_01_4.html">Ogre::isPodLike&lt; int &gt;</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1isPodLike_3_01unsigned_01_4.html">Ogre::isPodLike&lt; unsigned &gt;</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1isPodLike_3_01short_01_4.html">Ogre::isPodLike&lt; short &gt;</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1isPodLike_3_01unsigned_01short_01_4.html">Ogre::isPodLike&lt; unsigned short &gt;</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1isPodLike_3_01long_01_4.html">Ogre::isPodLike&lt; long &gt;</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1isPodLike_3_01unsigned_01long_01_4.html">Ogre::isPodLike&lt; unsigned long &gt;</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1isPodLike_3_01float_01_4.html">Ogre::isPodLike&lt; float &gt;</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1isPodLike_3_01double_01_4.html">Ogre::isPodLike&lt; double &gt;</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1isPodLike_3_01T_01_5_01_4.html">Ogre::isPodLike&lt; T * &gt;</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1isPodLike_3_01std_1_1pair_3_01T_00_01U_01_4_01_4.html">Ogre::isPodLike&lt; std::pair&lt; T, U &gt; &gt;</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SmallVectorBase.html">Ogre::SmallVectorBase</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="classOgre_1_1SmallVectorBase.html" title="SmallVectorBase - This is all the non-templated stuff common to all SmallVectors.">SmallVectorBase</a> - This is all the non-templated stuff common to all SmallVectors.  <a href="classOgre_1_1SmallVectorBase.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">union &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="unionOgre_1_1SmallVectorBase_1_1U.html">Ogre::SmallVectorBase::U</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SmallVectorTemplateCommon.html">Ogre::SmallVectorTemplateCommon&lt; T &gt;</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SmallVectorTemplateBase.html">Ogre::SmallVectorTemplateBase&lt; T, isPodLike &gt;</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="classOgre_1_1SmallVectorTemplateBase.html" title="SmallVectorTemplateBase&lt;isPodLike = false&gt; - This is where we put method implementations that are desig...">SmallVectorTemplateBase</a>&lt;<a class="el" href="structOgre_1_1isPodLike.html">isPodLike</a> = false&gt; - This is where we put method implementations that are designed to work with non-POD-like T's.  <a href="classOgre_1_1SmallVectorTemplateBase.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SmallVectorTemplateBase_3_01T_00_01true_01_4.html">Ogre::SmallVectorTemplateBase&lt; T, true &gt;</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="classOgre_1_1SmallVectorTemplateBase.html" title="SmallVectorTemplateBase&lt;isPodLike = false&gt; - This is where we put method implementations that are desig...">SmallVectorTemplateBase</a>&lt;<a class="el" href="structOgre_1_1isPodLike.html">isPodLike</a> = true&gt; - This is where we put method implementations that are designed to work with POD-like T's.  <a href="classOgre_1_1SmallVectorTemplateBase_3_01T_00_01true_01_4.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SmallVectorImpl.html">Ogre::SmallVectorImpl&lt; T &gt;</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="classOgre_1_1SmallVectorImpl.html" title="SmallVectorImpl - This class consists of common code factored out of the SmallVector class to reduce ...">SmallVectorImpl</a> - This class consists of common code factored out of the <a class="el" href="classOgre_1_1SmallVector.html" title="SmallVector - This is a &#39;vector&#39; (really, a variable-sized array), optimized for the case when the ar...">SmallVector</a> class to reduce code duplication based on the <a class="el" href="classOgre_1_1SmallVector.html" title="SmallVector - This is a &#39;vector&#39; (really, a variable-sized array), optimized for the case when the ar...">SmallVector</a> 'N' template parameter.  <a href="classOgre_1_1SmallVectorImpl.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SmallVector.html">Ogre::SmallVector&lt; T, N &gt;</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="classOgre_1_1SmallVector.html" title="SmallVector - This is a &#39;vector&#39; (really, a variable-sized array), optimized for the case when the ar...">SmallVector</a> - This is a 'vector' (really, a variable-sized array), optimized for the case when the array is small.  <a href="classOgre_1_1SmallVector.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SmallVector_3_01T_00_010_01_4.html">Ogre::SmallVector&lt; T, 0 &gt;</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Specialize <a class="el" href="classOgre_1_1SmallVector.html" title="SmallVector - This is a &#39;vector&#39; (really, a variable-sized array), optimized for the case when the ar...">SmallVector</a> at N=0.  <a href="classOgre_1_1SmallVector_3_01T_00_010_01_4.html#details">More...</a><br/></td></tr>
<tr><td colspan="2"><h2><a name="namespaces"></a>
Namespaces</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">namespace &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceOgre.html">Ogre</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">namespace &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacestd.html">std</a></td></tr>
<tr><td colspan="2"><h2><a name="func-members"></a>
Functions</h2></td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename T &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272">std::swap</a> (<a class="el" href="classOgre_1_1SmallVectorImpl.html">Ogre::SmallVectorImpl</a>&lt; T &gt; &amp;LHS, <a class="el" href="classOgre_1_1SmallVectorImpl.html">Ogre::SmallVectorImpl</a>&lt; T &gt; &amp;RHS)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Implement <a class="el" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a> in terms of SmallVector swap.  <a href="#ac0f5c834836c0f5a4602cff74511d272"></a><br/></td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename T , unsigned N&gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespacestd.html#af60633ec58754c4b3cc2c56314bf1882">std::swap</a> (<a class="el" href="classOgre_1_1SmallVector.html">Ogre::SmallVector</a>&lt; T, N &gt; &amp;LHS, <a class="el" href="classOgre_1_1SmallVector.html">Ogre::SmallVector</a>&lt; T, N &gt; &amp;RHS)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Implement <a class="el" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a> in terms of SmallVector swap.  <a href="#af60633ec58754c4b3cc2c56314bf1882"></a><br/></td></tr>
</table>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:53
</p>
</body>
</html>
